//
//  MIDI_Controller.m
//  MIDI Tool
//
//  Created by John Geelen on 23-05-11.
//  Copyright 2011 JG Electronics. All rights reserved.
//	Remarks, reports to: www.jgelectronics.nl.
//
//	Derived from Apple's example program MIDI Echo and PlaySoftMIDI.
//	Nanosecond Timing in OS X used in printPacketInfo: http://developer.apple.com/qa/qa2004/qa1398.html
//	The application icon is from Vincent Garnier http://benjigarner.deviantart.com/art/Fruity-Apples-80805804
//
//	Cocoa, OSX10.6 and XCODE 4.0.1
//
/*
 Disclaimer: IMPORTANT: 
 This JG Electronics software is supplied to you by JG Electronics as FREE AND OPEN SOURCE SOFTWARE. 
 
 The JG Electronics Software is provided by JG Electronics on an "AS IS" basis.
 JG ELECTRONICS MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE JG ELECTRONICS SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL JG ELECTRONICS BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE JG ELECTRONICS SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF JG ELECTRONICS HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

#import "MIDI_Controller.h"

#define MESSAGESIZE 3

	#pragma mark -
	#pragma mark === Static Methods ===
//	*********************************************************************************************************************************
//	static void myMIDINotifyProc(const MIDINotification *message, void *refCon);
//	static void	MyReadProc(const MIDIPacketList *pktlist, void *refCon, void *connRefCon);

	@implementation MIDI_Controller

	#pragma mark -
	#pragma mark === Accessor Methods ===
//	*********************************************************************************************************************************
//	@synthesize	real, imag, magn, fase;

	#pragma mark -
	#pragma mark === Internal Methods ===
//	*********************************************************************************************************************************
- (void)awakeFromNib
{
//	my inits
//	init popup buttons
	[midiChnInPopUp removeAllItems];
	[midiChnInPopUp addItemWithTitle:@"Channel 1"];
	[midiChnInPopUp addItemWithTitle:@"Channel 2"];
	[midiChnInPopUp addItemWithTitle:@"Channel 3"];
	[midiChnInPopUp addItemWithTitle:@"Channel 4"];
	[midiChnInPopUp addItemWithTitle:@"Channel 5"];
	[midiChnInPopUp addItemWithTitle:@"Channel 6"];
	[midiChnInPopUp addItemWithTitle:@"Channel 7"];
	[midiChnInPopUp addItemWithTitle:@"Channel 8"];
	[midiChnInPopUp addItemWithTitle:@"Channel 9"];
	[midiChnInPopUp addItemWithTitle:@"Channel 10"];
	[midiChnInPopUp addItemWithTitle:@"Channel 11"];
	[midiChnInPopUp addItemWithTitle:@"Channel 12"];
	[midiChnInPopUp addItemWithTitle:@"Channel 13"];
	[midiChnInPopUp addItemWithTitle:@"Channel 14"];
	[midiChnInPopUp addItemWithTitle:@"Channel 15"];
	[midiChnInPopUp addItemWithTitle:@"Channel 16"];
//
	[midiChnOutPopUp removeAllItems];
	[midiChnOutPopUp addItemWithTitle:@"Channel 1"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 2"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 3"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 4"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 5"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 6"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 7"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 8"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 9"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 10"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 11"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 12"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 13"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 14"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 15"];
	[midiChnOutPopUp addItemWithTitle:@"Channel 16"];
//
	[self mcMidiSetUp];
}

- (id)init
{
	if(![super init])
		return nil;
		
	NSNotificationCenter *	nc = [NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(mcMIDISetupChangeNotification:) name:@"MIDISetupChanged" object:nil];
	[nc addObserver:self selector:@selector(mcMIDIMessageNotification:) name:@"MIDIMessage" object:nil];
	midiPlayerPtr = [[MIDI_PLayer alloc] init];
	midiModelPtr = [[MIDI_Model alloc] init];
	
	return self;
}

- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	[midiPlayerPtr release];
	[midiModelPtr release];
	
	[super dealloc];
}

	#pragma mark -
	#pragma mark === Notification Methods ===
//	*********************************************************************************************************************************
- (void)mcMIDISetupChangeNotification:(NSNotification *)notification
{
	NSLog(@"mcMIDISetupChangeNotification");
	NSInteger	i;
	NSString *	titleSrc;
	NSString *	titleDest;
	BOOL		result;
	NSInteger	index;
	
	[midiModelPtr mmCloseConnectionFromSource:gSource];
	gDest = nulDev;
	
	titleSrc = [midiDevInPopUp itemTitleAtIndex:[midiDevInPopUp indexOfSelectedItem]];
	titleDest = [midiDevOutPopUp itemTitleAtIndex:[midiDevOutPopUp indexOfSelectedItem]];
/*	
	NSLog(@"titleSrc: %@",titleSrc);
	NSLog(@"titleDest: %@",titleDest);
*/	
	[self mcEnumerateSources];
	[self mcEnumerateDestinations];
// sources	
	index = -1;
	for(i = 0; i < [midiDevInPopUp numberOfItems]; i++){
		NSLog(@"titleIn: %@", [midiDevInPopUp itemTitleAtIndex:i]);
		result = [titleSrc compare: [midiDevInPopUp itemTitleAtIndex:i]] == NSOrderedSame;
		if(result == YES){
			index = i;
		} 
		if(index == -1){
			[midiDevInPopUp selectItem:[midiDevInPopUp lastItem]];
			gSource = nulDev;
		} else {
			[midiDevInPopUp selectItemAtIndex:index];
			gSource = MIDIGetSource(index);
			[midiModelPtr mmOpenConnectionFromSource:gSource];
		}
	}
// destinations
	index = -1;
	for(i = 0; i < [midiDevOutPopUp numberOfItems]; i++){
		NSLog(@"titleOut: %@", [midiDevOutPopUp itemTitleAtIndex:i]);
		NSLog(@"titleDest: %@", titleDest);
		result = [titleDest compare:[midiDevOutPopUp itemTitleAtIndex:i]] == NSOrderedSame;
		if(result == YES){
			index = i;
		}
		if(index == -1){
			[midiDevOutPopUp selectItem:[midiDevOutPopUp lastItem]];
			gDest = nulDev;
		} else {
			[midiDevOutPopUp selectItemAtIndex:index];
			gDest = MIDIGetDestination(index);
		}
	}
}

- (void)mcMIDIMessageNotification:(NSNotification *)notification
{
	NSLog(@"notification");
	[self performSelectorOnMainThread:@selector(setMessageInMainThread:) withObject:nil waitUntilDone:YES];
		//	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init]; 
		//	[self mcStringToTextView:@"Received MIDI Note"];
		//	[pool release];
}

- (void)setMessageInMainThread:(id)object
{
	[self mcStringToTextView:@"Received MIDI Note"];
}

	#pragma mark -
	#pragma mark === MIDI Methods ===
//	*********************************************************************************************************************************
- (void)mcMidiSetUp
{
//	NSLog(@"mcMidiSetUp");
	int i;
	unsigned long		n;
	int					isOffline;
	CFStringRef			pname, pmanuf, pmodel;
//	char				name[64];
//	char				name[64], manuf[64], model[64];
	NSMutableString *	resultString;
//	OSStatus			status;

//	create client and ports
	[midiModelPtr mmMidiSetUp];
	
//	enumerate devices, entities
	n = MIDIGetNumberOfDevices();
	for (i = 0; i < n; ++i) {
		resultString = [[NSMutableString alloc]initWithString:@""];
		MIDIDeviceRef dev = MIDIGetDevice(i);
		isOffline = 0;
		
		MIDIObjectGetStringProperty(dev, kMIDIPropertyName, &pname);
		MIDIObjectGetStringProperty(dev, kMIDIPropertyManufacturer, &pmanuf);
		MIDIObjectGetStringProperty(dev, kMIDIPropertyModel, &pmodel);
		MIDIObjectGetIntegerProperty(dev, kMIDIPropertyOffline, &isOffline);
	/*	
		 CFStringGetCString(pname, name, sizeof(name), 0);
		 CFStringGetCString(pmanuf, manuf, sizeof(manuf), 0);
		 CFStringGetCString(pmodel, model, sizeof(model), 0);
		 printf("name=%s, manuf=%s, model=%s\n", name, manuf, model);
	
		 NSLog(@"name: %@",pname);
		 NSLog(@"manuf: %@",pmanuf);
		 NSLog(@"model: %@",pmodel);
		 NSLog(@"Device online: %s", (isOffline ? "No" : "Yes"));
	*/
	//	result view
		[resultString appendString:@"name:                 "];
		[resultString appendString:(NSString *)pname];
		[resultString appendString:@"\rmanufacturer:   "];
		[resultString appendString:(NSString *)pmanuf];
		[resultString appendString:@"\rmodel:                "];
		[resultString appendString:(NSString *)pmodel];
		if(isOffline == 0) {
			[resultString appendString:@"\ron line:               YES"];
		}
		else {
			[resultString appendString:@"\ron line:               NO"];
		}
		
		[self mcStringToTextView:resultString];
	//	releases
		CFRelease(pname);
		CFRelease(pmanuf);
		CFRelease(pmodel);
		[resultString release];
	}
	[self mcEnumerateSources];
	[self mcEnumerateDestinations];
}

- (void)mcEnumerateSources
{
	unsigned long		n;
	int					i;
	CFStringRef			pname;
	NSMutableString *	resultString;
	
//	enumerate sources, virtual sources don't have entities
	n = MIDIGetNumberOfSources();
	NSLog(@"sources: %lu",n);
	[midiDevInPopUp removeAllItems];
	if(n == 0) {
		[midiDevInPopUp addItemWithTitle:@"[None]"];
		gSource = nulDev;
	}
	else {
		for (i = 0; i < n; ++i) {
			gSource = MIDIGetSource(i);
			MIDIObjectGetStringProperty(gSource, kMIDIPropertyDisplayName, &pname);
		//	popup
			[midiDevInPopUp addItemWithTitle:(NSString *)pname];
		//	result view
			resultString = [[NSMutableString alloc]initWithString:@""];
			[resultString appendString:@"display name:    "];
			[resultString appendString:(NSString *)pname];
			[self mcStringToTextView:resultString];
		//	releases
			CFRelease(pname);
			[resultString release];
		}
		[[midiDevInPopUp menu] addItem:[NSMenuItem separatorItem]];
		[midiDevInPopUp addItemWithTitle:@"[None]"];
		[midiDevInPopUp selectItemAtIndex:0];
		gSource = MIDIGetSource(0);
//		MIDIPortConnectSource(gInPort, gSource, NULL);
		[midiModelPtr mmOpenConnectionFromSource:gSource];
	}
}

- (void)mcEnumerateDestinations
{
	unsigned long		n;
	int					i;
	CFStringRef			pname;
	NSMutableString *	resultString;
	
//	enumerate destinations, virtual destinations don't have entities
	n = MIDIGetNumberOfDestinations();
	NSLog(@"destinations: %lu",n);
	[midiDevOutPopUp removeAllItems];
	if(n == 0) {
		[midiDevOutPopUp addItemWithTitle:@"[None]"];
		gDest = nulDev;
	}
	else {
		for (i = 0; i < n; ++i) {
			gDest = MIDIGetDestination(i);
			MIDIObjectGetStringProperty(gDest, kMIDIPropertyDisplayName, &pname);
		//	popup
			[midiDevOutPopUp addItemWithTitle:(NSString *)pname];
		//	result view
			resultString = [[NSMutableString alloc]initWithString:@""];
			[resultString appendString:@"display name:    "];
			[resultString appendString:(NSString *)pname];
			[self mcStringToTextView:resultString];
		//	releases
			CFRelease(pname);
			[resultString release];
		}
		[[midiDevOutPopUp menu] addItem:[NSMenuItem separatorItem]];
		[midiDevOutPopUp addItemWithTitle:@"[None]"];
		[midiDevOutPopUp selectItemAtIndex:0];
		gDest = MIDIGetDestination(0);
	}
}

- (void)mcMIDITestMessage
{
	NSLog(@"mcMIDITestMessage");
	OSStatus			result;
	int					i;
		
// Prepare a MIDI Note-On message to send 
	MIDITimeStamp timestamp = mach_absolute_time(); 
	Byte buffer[1024];             // storage space for MIDI Packets (max 65536)
	MIDIPacketList *	packetlist = (MIDIPacketList*)buffer;
	MIDIPacket *		currentpacket = MIDIPacketListInit(packetlist);
//	Byte				notemessage[MESSAGESIZE] = {0x90, 60, 90};	//	pitch = C3
	UInt8				notemessage[MESSAGESIZE];
	NSMutableString *	resultString;
	
//	we're going to play an octave of MIDI notes: one a second
	notemessage[0] = 0x90;			//	turn on note channel 1. Is the same for note on and note off. Note off velocity = 0
	for (i = 0; i < 13; i++) {
		NSLog(@"mcMIDITestMessage");
		notemessage[1] = i + 60;	//	pitch = C#3
		notemessage[2] = 127;		//	velocity
		currentpacket = MIDIPacketListAdd(packetlist, sizeof(buffer), currentpacket, timestamp, MESSAGESIZE, notemessage);
		timestamp += 1000000000;	//	one billion nanoseconds = 1 second later
		notemessage[2] = 0;
		currentpacket = MIDIPacketListAdd(packetlist, sizeof(buffer), currentpacket, timestamp, MESSAGESIZE, notemessage);
	}
// send the MIDI data
	BOOL succes = [midiModelPtr mmSendMidi:gDest packetList:packetlist];
	if(succes == NO) {
		NSLog(@"problem to send MIDI data");
	}

//	sleep(5);

//	play midi notes 60...72,  C3...C4
	[midiPlayerPtr mpStartGraph];
	
	for (i = 0; i < 13; i++) {
		result = [midiPlayerPtr mpPlayMidiNote:i + 60 velocity:127 channel:0];
	//	sleep for a second
		usleep (1 * 1000 * 1000);
		result = [midiPlayerPtr mpPlayMidiNote:i + 60 velocity:0 channel:0];
	}

	[midiPlayerPtr mpStopGraph];
	
	resultString = [[NSMutableString alloc]initWithString:@"\rTest message send:\rone octave, MIDI note 60...72, C3...C4\r"];
	[resultString appendString:@"\rnote 60,  C3,    on/off,  velocety 127"];
	[resultString appendString:@"\rnote 61,  C3#,  on/off,  velocety 127"];
	[resultString appendString:@"\rnote 62,  D3,    on/off,  velocety 127"];
	[resultString appendString:@"\rnote 63,  D3#,  on/off,  velocety 127"];
	[resultString appendString:@"\rnote 64,  E3,    on/off,  velocety 127"];
	[resultString appendString:@"\rnote 65,  F3,    on/off,  velocety 127"];
	[resultString appendString:@"\rnote 66,  F3#,  on/off,  velocety 127"];
	[resultString appendString:@"\rnote 67,  G3,    on/off,  velocety 127"];
	[resultString appendString:@"\rnote 68,  G3#,  on/off,  velocety 127"];
	[resultString appendString:@"\rnote 69,  A3,    on/off,  velocety 127"];
	[resultString appendString:@"\rnote 70,  A3#,  on/off,  velocety 127"];
	[resultString appendString:@"\rnote 71,  B3,    on/off,  velocety 127"];
	[resultString appendString:@"\rnote 72,  C4,    on/off,  velocety 127"];
	[self mcStringToTextView:resultString];
	[resultString release];
	
/*
//	general MIDI data info.
	note on ($9n)			data format:
	status byte:	1001nnnn	channel#	nnnn:		0...15	($00...$0F)
	1e data byte:	0kkkkkkk	key#		kkkkkkkk:	0...127	($00...$7F)
	2e data byte:	0vvvvvvv	velocity#	vvvvvvvv:	0...127	($00...$7F)
	 
	note off ($8n)			data format:
	status byte:	1000nnnn	channel#	nnnn:		0...15	($00...$0F)
	1e data byte:	0kkkkkkk	key#		kkkkkkkk:	0...127	($00...$7F)
	2e data byte:	0vvvvvvv	velocity#	vvvvvvvv:	0...127	($00...$7F)
	 
	control change ($Bn)	data format:
	status byte:	1011nnnn	channel#	nnnn:		0...15	($00...$0F)
	1e data byte:	0ccccccc	control#	cccccccc:	0...127	($00...$7F)
	2e data byte:	0vvvvvvv	value#		vvvvvvvv:	0...127	($00...$7F)
	 
	program change ($Cn)	data format:
	status byte:	1100nnnn	channel#	nnnn:		0...15	($00...$0F)
	1e data byte:	0ppppppp	program#	pppppppp:	0...127	($00...$7F)
	 
	system commands			data format:
	status byte:	11111000	(&F8)	timing clock
	status byte:	11111001	(&F9)	not defined
	status byte:	11111010	(&FA)	start
	status byte:	11111011	(&FB)	continue
	status byte:	11111100	(&FC)	stop
	status byte:	11111101	(&FD)	not defined
	status byte:	11111110	(&FE)	active sensing
	status byte:	11111111	(&FF)	system reset
*/
}

	#pragma mark -
	#pragma mark === Action Methods ===
//	*********************************************************************************************************************************
- (IBAction)mcReadButtons:(id)sender
{	
	NSString *	itemTitle;
	
	switch([sender tag])
	{
		case 1:		//	midi source endpoint
					//	MIDIPortDisconnectSource(gInPort, gSource);
			[midiModelPtr mmCloseConnectionFromSource:gSource];
			itemTitle = [midiDevInPopUp itemTitleAtIndex:[midiDevInPopUp indexOfSelectedItem]];
			if((itemTitle == @"")||(itemTitle == @"[None]")) {
				gSource = nulDev;
			}
			else {
				gSource = MIDIGetSource([midiDevInPopUp indexOfSelectedItem]);
				[midiModelPtr mmOpenConnectionFromSource:gSource];
			}
		//	NSLog(@"[midiDevInPopUp indexOfSelectedItem]: %lu",[midiDevInPopUp indexOfSelectedItem]);
			break;
		case 2:		//	midi source channel
			gInChannel = (Byte)[midiChnInPopUp indexOfSelectedItem];
			break;
		case 3:		//	midi destination endpoint
			itemTitle = [midiDevOutPopUp itemTitleAtIndex:[midiDevOutPopUp indexOfSelectedItem]];
			NSLog(@"itemTitle %@",itemTitle);
			if((itemTitle == @"")||(itemTitle == @"[None]")) {
				gDest = nulDev;
			}
			else {
				NSLog(@"MIDIGetDestination");
				gDest = MIDIGetDestination([midiDevOutPopUp indexOfSelectedItem]);
			}
			break;
		case 4:		//	midi destination channel
			gOutChannel = (Byte)[midiChnOutPopUp indexOfSelectedItem];
			break;
		case 10:		//	open connections from all sources
			[midiModelPtr mmOpenConnectionsFromAllSources];
			break;
		case 11:		//	close connections from all sources
			[midiModelPtr mmCloseConnectionsFromAllSources];
			break;
		case 12:		//	test sequence C3...C4
			[self mcMIDITestMessage];
			break;
	}
}

	#pragma mark -
	#pragma mark === Text View Methods ===
//	*********************************************************************************************************************************
- (void)mcStringToTextView:(NSString *)resultStr
{
//	NSLog(@"mcStringToTextView");
//	NSLog(@"resultStr: %@",resultStr);
	NSMutableString * tempMuString = [[NSMutableString alloc]initWithString:resultStr];
	[tempMuString appendString:@"\r\r"];
	[mcResultView setEditable:YES];
	[mcResultView setContinuousSpellCheckingEnabled:NO];
	[mcResultView insertText:tempMuString];
	[mcResultView setEditable:NO];
	[mcResultView setNeedsDisplay:YES];
	[tempMuString release];
}

- (void)mcDeletetext
{
	[mcResultView setEditable:YES];
	[mcResultView selectAll:self];
	[mcResultView delete:self];
	[mcResultView setEditable:NO];
}

@end
