//
//  MIDI_Model.h
//  MIDI Tool
//
//  Created by John Geelen on 23-05-11.
//  Copyright 2011 JG Electronics. All rights reserved.
//	Remarks, reports to: www.jgelectronics.nl.
//
//	Derived from Apple's example program MIDI Echo and PlaySoftMIDI.
//	Nanosecond Timing in OS X used in printPacketInfo: http://developer.apple.com/qa/qa2004/qa1398.html
//	The application icon is from Vincent Garnier http://benjigarner.deviantart.com/art/Fruity-Apples-80805804
//
//	Cocoa, OSX10.6 and XCODE 4.0.1
//
/*
 Disclaimer: IMPORTANT: 
 This JG Electronics software is supplied to you by JG Electronics as FREE AND OPEN SOURCE SOFTWARE. 
 
 The JG Electronics Software is provided by JG Electronics on an "AS IS" basis.
 JG ELECTRONICS MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE JG ELECTRONICS SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL JG ELECTRONICS BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE JG ELECTRONICS SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF JG ELECTRONICS HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

#import "MIDI_ToolHeader.h"

@interface MIDI_Model : NSObject
{
		//	MIDI_Controller *			midiContrPtr;
	MIDIPortRef					PortIn;
	MIDIEndpointRef				Source;
	Byte						channelIn;
	MIDIPortRef					PortOut;
	MIDIEndpointRef				Destination;
	Byte						channelOut;
}

@property(readwrite, assign) Byte	channelIn, channelOut;

- (void)mmMidiSetUp;
- (void)SetMidiChannelIn:(Byte)channel;
- (void)SetMidiChannelOut:(Byte)channel;
- (void)mmOpenConnectionFromSource:(MIDIEndpointRef)source;
- (void)mmCloseConnectionFromSource:(MIDIEndpointRef)source;
- (BOOL)mmSendMidi:(MIDIEndpointRef)destination packetList:(MIDIPacketList *)packetlist;
- (void)mmOpenConnectionsFromAllSources;
- (void)mmCloseConnectionsFromAllSources;

//	void printPacketInfo(const MIDIPacket* packet);
- (void)printPacketInfo:(const MIDIPacket*) packet;


@end
